/**
 * @license
 * @version 0.3.0
 * The MIT License (MIT)
 * 
 * Copyright (c) 2015 Thomas Roch
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
define("router5",[],function(){var t={ROUTER_NOT_STARTED:"NOT_STARTED",ROUTER_ALREADY_STARTED:"ALREADY_STARTED",SAME_STATES:"SAME_STATES",CANNOT_DEACTIVATE:"CANNOT_DEACTIVATE",CANNOT_ACTIVATE:"CANNOT_ACTIVATE",NODE_LISTENER_ERR:"NODE_ERR",TRANSITION_CANCELLED:"CANCELLED"};function e(){var t=arguments;return function(){return t[0]}}var n=function n(){};var a=typeof window!=="undefined";var r=function r(){return window.location.pathname.replace(/\/$/,"")};var i=function i(t,e,n){return window.history.pushState(t,e,n)};var s=function s(t,e,n){return window.history.replaceState(t,e,n)};var u=function u(t){return window.addEventListener("popstate",t)};var o=function o(t){return window.removeEventListener("popstate",t)};var l=function l(t){var e=t.useHash?window.location.hash.replace(new RegExp("^#"+t.hashPrefix),""):window.location.pathname.replace(new RegExp("^"+t.base),"");return e+window.location.search};var f={};if(a){f={getBase:r,pushState:i,replaceState:s,addPopstateListener:u,removePopstateListener:o,getLocation:l}}else{f={getBase:e(""),pushState:n,replaceState:n,addPopstateListener:n,removePopstateListener:n,getLocation:e("")}}function c(t,e,n,a){var r=arguments[4]===undefined?false:arguments[4];var i=t||[];var s=function s(t){if(!i.length)return true;var a=i[0].length;var s=i[0](e,n,t);if(typeof s==="boolean")t(s?null:true);else if(s&&typeof s.then==="function"){s.then(function(){return t(null)},function(){return t(true)})}else if(a<3&&r)t(null);return false};var u=function u(t){if(t)a(t);else{i=i.slice(1);o()}};var o=function o(){var t=s(u);if(t)a(null)};o()}var h=function h(t){return t.split(".").reduce(function(t,e){return t.concat(t.length?t[t.length-1]+"."+e:e)},[])};function v(e,n,a,r){var i=false;var s=function s(){return i=true};var u=function u(e){return r(i?t.TRANSITION_CANCELLED:e)};var o=undefined;var l=a?h(a.name):[];var f=h(n.name);var v=Math.min(l.length,f.length);for(o=0;o<v;o+=1){if(l[o]!==f[o])break}var d=l.slice(o).reverse();var p=f.slice(o);var m=a&&o>0?l[o-1]:"";var S=function S(n,a,r){if(i)u();else{var s=d.map(function(t){return e._cmps[t]}).filter(function(t){return t&&t.canDeactivate}).map(function(t){return t.canDeactivate});c(s,n,a,function(e){return r(e?t.CANNOT_DEACTIVATE:null)})}};var _=function _(n,a,r){if(i)u();else{var s=p.map(function(t){return e._canAct[t]}).filter(function(t){return t});c(s,n,a,function(e){return r(e?t.CANNOT_ACTIVATE:null)})}};var E=function E(n,a,r){if(i)u();else{var s=e._cbs["^"+m]||[];c(s,n,a,function(e){return r(e?t.NODE_LISTENER_ERR:null)},true)}};var A=a?[S,_,E]:[_,E];c(A,n,a,u);return s}var d=Array.prototype.slice;var p=function p(t,e,n){return{name:t,params:e,path:n}};var m=function(){function e(t){var n=this;var a=arguments[1]===undefined?{}:arguments[1];_classCallCheck(this,e);this.started=false;this._cbs={};this._cmps={};this._canAct={};this.lastStateAttempt=null;this.lastKnownState=null;this.rootNode=t instanceof RouteNode?t:new RouteNode("","",t);this.options={useHash:false,hashPrefix:"",base:f.getBase()};Object.keys(a).forEach(function(t){return n.options[t]=a[t]});this.boundOnPopState=this.onPopState.bind(this)}_createClass(e,[{key:"setOption",value:function n(t,e){this.options[t]=e;return this}},{key:"add",value:function a(t){this.rootNode.add(t);return this}},{key:"addNode",value:function r(t,e,n){this.rootNode.addNode(t,e);if(n)this._canAct[t]=n;return this}},{key:"onPopState",value:function i(t){var e=this;var n=t.state||this.matchPath(this.getLocation());if(!n)return;if(this.lastKnownState&&this.areStatesEqual(n,this.lastKnownState))return;this._transition(n,this.lastKnownState,function(t){if(t){var n=e.buildUrl(e.lastKnownState.name,e.lastKnownState.params);f.pushState(e.lastKnownState,"",n)}})}},{key:"start",value:function s(){var e=this;var n=[].concat(d.call(arguments));var a=n.slice(-1)[0];var r=undefined,i=undefined;if(this.started){if(a)a(t.ROUTER_ALREADY_STARTED);return this}if(n.length===2){if(typeof n[0]==="string")r=n[0];if(typeof n[0]==="object")i=n[0]}this.started=true;var s=this.options;var u=function u(t,n){f.addPopstateListener(e.boundOnPopState);if(a)a(t,n)};if(!r&&!i)r=this.getLocation();if(!i){(function(){i=e.matchPath(r);var t=function t(){return e.navigate(s.defaultRoute,s.defaultParams,{replace:true},u)};if(i){e.lastStateAttempt=i;e._transition(e.lastStateAttempt,e.lastKnownState,function(n,a){if(!n){f.replaceState(e.lastKnownState,"",e.buildUrl(i.name,i.params));u(null,a)}else if(s.defaultRoute)t();else u(n)})}else if(s.defaultRoute){t()}else{u(null)}})()}else{this.lastKnownState=i;u(null,i)}return this}},{key:"stop",value:function u(){if(!this.started)return this;this.lastKnownState=null;this.lastStateAttempt=null;this.started=false;f.removePopstateListener(this.boundOnPopState);return this}},{key:"getState",value:function o(){return this.lastKnownState}},{key:"isActive",value:function l(t){var e=arguments[1]===undefined?{}:arguments[1];var n=arguments[2]===undefined?false:arguments[2];var a=this.getState();if(!a)return false;if(n||a.name===t){return this.areStatesEqual(p(t,e),a)}return this.areStatesDescendants(p(t,e),a)}},{key:"areStatesEqual",value:function c(t,e){return t.name===e.name&&Object.keys(t.params).length===Object.keys(e.params).length&&Object.keys(t.params).every(function(n){return t.params[n]===e.params[n]})}},{key:"areStatesDescendants",value:function h(t,e){var n=new RegExp("^"+t.name+"\\.(.*)$");if(!n.test(e.name))return false;return Object.keys(t.params).every(function(n){return t.params[n]===e.params[n]})}},{key:"_invokeListeners",value:function m(t,e,n){(this._cbs[t]||[]).forEach(function(t){return t(e,n)})}},{key:"_addListener",value:function S(t,e,n){var a=t.replace(/^(\*|\^|=)/,"");if(a){var r=this.rootNode.getSegmentsByName(a);if(!r)console.warn("No route found for "+a+", listener might never be called!")}if(!this._cbs[t])this._cbs[t]=[];this._cbs[t]=(n?[]:this._cbs[t]).concat(e);return this}},{key:"_removeListener",value:function _(t,e){if(this._cbs[t])this._cbs[t]=this._cbs[t].filter(function(t){return t!==e});return this}},{key:"addListener",value:function E(t){return this._addListener("*",t)}},{key:"removeListener",value:function A(t){return this._removeListener("*",t)}},{key:"addNodeListener",value:function T(t,e){return this._addListener("^"+t,e,true)}},{key:"removeNodeListener",value:function y(t,e){this._cbs["^"+t]=[];return this}},{key:"addRouteListener",value:function N(t,e){return this._addListener("="+t,e)}},{key:"removeRouteListener",value:function w(t,e){return this._removeListener("="+t,e)}},{key:"registerComponent",value:function g(t,e){if(this._cmps[t])console.warn("A component was alread registered for route node "+t+".");this._cmps[t]=e;return this}},{key:"deregisterComponent",value:function R(t){delete this._cmps[t]}},{key:"canActivate",value:function L(t,e){this._canAct[t]=e;return this}},{key:"getLocation",value:function k(){return f.getLocation(this.options)}},{key:"buildUrl",value:function b(t,e){return this.options.base+(this.options.useHash?"#"+this.options.hashPrefix:"")+this.rootNode.buildPath(t,e)}},{key:"buildPath",value:function O(t,e){return this.rootNode.buildPath(t,e)}},{key:"matchPath",value:function C(t){var e=this.rootNode.matchPath(t);return e?p(e.name,e.params,t):null}},{key:"_transition",value:function P(t,e,n){var a=this;if(this._tr)this._tr();var r=v(this,t,e,function(r){a._tr=null;if(r){if(n)n(r);return}a.lastKnownState=t;a._invokeListeners("="+t.name,t,e);a._invokeListeners("*",t,e);if(n)n(null,t)});this._tr=r;return function(){return!r||r()}}},{key:"navigate",value:function D(e,n,a,r){if(n===undefined)n={};var i=this;if(a===undefined)a={};if(!this.started){r(t.ROUTER_NOT_STARTED);return}var s=this.buildPath(e,n);var u=this.buildUrl(e,n);if(!s)throw new Error('Could not find route "'+e+'"');var o=p(e,n,s);this.lastStateAttempt=o;var l=this.lastKnownState?this.areStatesEqual(this.lastKnownState,this.lastStateAttempt):false;if(l&&!a.reload){if(r)r(t.SAME_STATES);return}return this._transition(o,this.lastKnownState,function(t,e){if(t){if(r)r(t);return}f[a.replace?"replaceState":"pushState"](i.lastStateAttempt,"",u);if(r)r(null,e)})}}]);return e}();m.ERR=t;return{RouteNode:RouteNode,Router5:m}});